tbb_misc.h File Reference
`#include "tbb/tbb_stddef.h"`
`#include "tbb/tbb_machine.h"`
`#include "tbb/atomic.h"`
Include dependency graph for tbb_misc.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

struct | tbb::internal::int_to_type< int >
| Utility helper structure to ease overload resolution. More...
class | tbb::internal::FastRandom
| A fast random number generator. More...
class | tbb::internal::affinity_helper

## Namespaces

| tbb
| The graph class.
| tbb::internal
| Identifiers declared inside namespace internal should never be used directly by client code.

## Macros

#define | __TBB_OS_AFFINITY_SYSCALL_PRESENT ((__linux__ && !__ANDROID__) || (__FreeBSD_version >= 701000))
#define | __TBB_USE_OS_AFFINITY_SYSCALL (__TBB_OS_AFFINITY_SYSCALL_PRESENT && !__bg__)

## Enumerations

enum | tbb::internal::do_once_state { tbb::internal::do_once_uninitialized = 0 , tbb::internal::do_once_pending , tbb::internal::do_once_executed , tbb::internal::initialization_complete = do_once_executed }
| One-time initialization states. More...

## Functions

int | tbb::internal::AvailableHwConcurrency ()
| Returns maximal parallelism level supported by the current OS configuration. More...
size_t | tbb::internal::DefaultSystemPageSize ()
| Returns OS regular memory page size. More...
void | tbb::internal::handle_win_error (int error_code)
| Throws std::runtime_error with what() returning error_code description prefixed with aux_info. More...
void | tbb::internal::PrintVersion ()
| Prints TBB version information on stderr. More...
void | tbb::internal::PrintExtraVersionInfo (const char *category, const char *format,...)
| Prints arbitrary extra TBB version information on stderr. More...
void | tbb::internal::PrintRMLVersionInfo (void *arg, const char *server_info)
| A callback routine to print RML version information on stderr. More...
template<typename T >
T | tbb::internal::min (const T &val1, const T &val2)
| Utility template function returning lesser of the two values. More...
template<typename T >
T | tbb::internal::max (const T &val1, const T &val2)
| Utility template function returning greater of the two values. More...
unsigned | tbb::internal::GetPrime (unsigned seed)
template<typename T1 , typename T2 , class Pred >
T1 | tbb::internal::atomic_update (tbb::atomic< T1 > &dst, T2 newValue, Pred compare)
| Atomically replaces value of dst with newValue if they satisfy condition of compare predicate. More...
template<typename F >
void | tbb::internal::atomic_do_once (const F &initializer, atomic< do_once_state > &state)
| One-time initialization function. More...
void | tbb::internal::run_initializer (void(*f)(), atomic< do_once_state > &state)
void | tbb::internal::run_initializer (bool(*f)(), atomic< do_once_state > &state)
void | tbb::internal::destroy_process_mask ()
bool | tbb::internal::cpu_has_speculation ()
| check for transaction support. More...
bool | tbb::internal::gcc_rethrow_exception_broken ()
void | tbb::internal::fix_broken_rethrow ()

## Variables

const size_t | tbb::internal::MByte = 1024*1024
const size_t | tbb::internal::ThreadStackSize = (sizeof(uintptr_t) <= 4 ? 2 : 4 )*MByte

## Macro Definition Documentation

## __TBB_OS_AFFINITY_SYSCALL_PRESENT

#define __TBB_OS_AFFINITY_SYSCALL_PRESENT ((__linux__ && !__ANDROID__) || (__FreeBSD_version >= 701000))

Definition at line 36 of file tbb_misc.h.

## __TBB_USE_OS_AFFINITY_SYSCALL

#define __TBB_USE_OS_AFFINITY_SYSCALL (__TBB_OS_AFFINITY_SYSCALL_PRESENT && !__bg__)

Definition at line 39 of file tbb_misc.h.

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.